## actor-framework 0.17.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(caf CXX)

# Set default install paths.
# See https://cmake.org/cmake/help/latest/module/GNUInstallDirs.html
include(GNUInstallDirs)

get_directory_property(_parent PARENT_DIRECTORY)
if(_parent)
  set(caf_is_subproject ON)
else()
  set(caf_is_subproject OFF)
endif()
unset(_parent)

# Be nice to VIM users and Clang tools.
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

# Silence policy CMP0042 warning by enabling RPATH explicitly.
if(APPLE AND NOT DEFINED CMAKE_MACOSX_RPATH)
  set(CMAKE_MACOSX_RPATH true)
endif()

# Shared libs are currently not supported on Windows.
if(WIN32 AND NOT CAF_BUILD_STATIC_ONLY)
  message(STATUS "CAF currently only supports static-only builds on Windows")
  set(CAF_BUILD_STATIC_ONLY yes)
endif()

if(CAF_BUILD_STATIC_RUNTIME)
    set(flags_configs
        CMAKE_CXX_FLAGS
        CMAKE_CXX_FLAGS_DEBUG
        CMAKE_CXX_FLAGS_RELEASE
        CMAKE_CXX_FLAGS_RELWITHDEBINFO
        CMAKE_CXX_FLAGS_MINSIZEREL
        CMAKE_C_FLAGS
        CMAKE_C_FLAGS_DEBUG
        CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_RELWITHDEBINFO
        CMAKE_C_FLAGS_MINSIZEREL
        )
  foreach(flags ${flags_configs})
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      if(NOT ${flags} MATCHES "-static-libstdc\\+\\+")
        set(${flags} "${${flags}} -static-libstdc++")
      endif()
      if(NOT ${flags} MATCHES "-static-libgcc")
        set(${flags} "${${flags}} -static-libgcc")
      endif()
    elseif(MSVC)
      if(${flags} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flags} "${${flags}}")
      endif()
    endif()
  endforeach()
else()
  set(CAF_BUILD_STATIC_RUNTIME no)
endif()

# add helper target that simplifies re-running configure
if(NOT caf_is_subproject)
  add_custom_target(configure COMMAND ${CMAKE_CURRENT_BINARY_DIR}/config.status)
endif()

################################################################################
#                              utility functions                               #
################################################################################

# Appends `str` to the variable named `var` with a whitespace as separator.
# Suppresses a leading whitespace if the variable is empty and does nothing if
# `str` is empty.
function(build_string var str)
  if(NOT str STREQUAL "")
    if("${${var}}" STREQUAL "")
      set("${var}" "${str}" PARENT_SCOPE)
    else()
      set("${var}" "${${var}} ${str}" PARENT_SCOPE)
    endif()
  endif()
endfunction(build_string)

# Forces `var` to 'no' if the content of the variables evaluates to false.
function(pretty_no var)
  if(NOT "${${var}}")
    set("${var}" no PARENT_SCOPE)
  endif()
endfunction(pretty_no)

# Forces `var` to 'yes' if the content of the variables evaluates to false.
function(pretty_yes var)
  if("${${var}}")
    set("${var}" yes PARENT_SCOPE)
  endif()
endfunction(pretty_yes)

add_executable(caf-generate-enum-strings
               EXCLUDE_FROM_ALL
               cmake/caf-generate-enum-strings.cpp)

add_custom_target(consistency-check)

add_custom_target(update-enum-strings)

# adds a consistency check that verifies that `cpp_file` is still valid by
# re-generating the file and comparing it to the existing file
function(add_enum_consistency_check hpp_file cpp_file)
  set(input "${CMAKE_CURRENT_SOURCE_DIR}/${hpp_file}")
  set(file_under_test "${CMAKE_CURRENT_SOURCE_DIR}/${cpp_file}")
  set(output "${CMAKE_CURRENT_BINARY_DIR}/check/${cpp_file}")
  get_filename_component(output_dir "${output}" DIRECTORY)
  file(MAKE_DIRECTORY "${output_dir}")
  add_custom_command(OUTPUT "${output}"
                     COMMAND caf-generate-enum-strings "${input}" "${output}"
                     DEPENDS caf-generate-enum-strings "${input}")
  get_filename_component(target_name "${input}" NAME_WE)
  add_custom_target("${target_name}"
                    COMMAND
                      "${CMAKE_COMMAND}"
                      "-Dfile_under_test=${file_under_test}"
                      "-Dgenerated_file=${output}"
                      -P "${PROJECT_SOURCE_DIR}/cmake/check-consistency.cmake"
                    DEPENDS "${output}")
  add_dependencies(consistency-check "${target_name}")
  add_custom_target("${target_name}-update"
                    COMMAND
                      caf-generate-enum-strings
                      "${input}"
                      "${file_under_test}"
                     DEPENDS caf-generate-enum-strings "${input}")
  add_dependencies(update-enum-strings "${target_name}-update")
endfunction()

################################################################################
#                        set prefix paths if available                         #
################################################################################

build_string("CMAKE_PREFIX_PATH" "${CAF_QT_PREFIX_PATH}")

################################################################################
#                      enable ccache if required by user                       #
################################################################################

if(CAF_USE_CCACHE)
  find_program(CCACHE_PROGRAM ccache)
  if(CCACHE_PROGRAM)
    message(STATUS "Using ccache command: ${CCACHE_PROGRAM}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
  else()
    message(STATUS "Unable to find ccache")
  endif()
endif(CAF_USE_CCACHE)

################################################################################
#      make sure config parameters are printed with yes or no in summary       #
################################################################################

pretty_yes("CAF_FORCE_NO_EXCEPTIONS")

pretty_no("CAF_ENABLE_RUNTIME_CHECKS")
pretty_no("CAF_NO_MEM_MANAGEMENT")
pretty_no("CAF_NO_EXCEPTIONS")
pretty_no("CAF_BUILD_STATIC_ONLY")
pretty_no("CAF_BUILD_STATIC")
pretty_no("CAF_NO_OPENCL")
pretty_no("CAF_NO_OPENSSL")
pretty_no("CAF_NO_PYTHON")
pretty_no("CAF_NO_TOOLS")
pretty_no("CAF_NO_SUMMARY")

if(NOT CAF_NO_IO)
  set(CAF_NO_IO no)
else()
  set(CAF_NO_TOOLS yes)
  set(CAF_NO_PYTHON yes)
endif()

################################################################################
#                              get version of CAF                              #
################################################################################

# read content of config.hpp
file(READ "libcaf_core/caf/config.hpp" CONFIG_HPP)
# get line containing the version
string(REGEX MATCH "#define CAF_VERSION [0-9]+" VERSION_LINE "${CONFIG_HPP}")
# extract version number from line
string(REGEX MATCH "[0-9]+" VERSION_INT "${VERSION_LINE}")
# calculate major, minor, and patch version
math(EXPR CAF_VERSION_MAJOR "${VERSION_INT} / 10000")
math(EXPR CAF_VERSION_MINOR "( ${VERSION_INT} / 100) % 100")
math(EXPR CAF_VERSION_PATCH "${VERSION_INT} % 100")
# create full version string
set(CAF_VERSION
    "${CAF_VERSION_MAJOR}.${CAF_VERSION_MINOR}.${CAF_VERSION_PATCH}")
# set the library version for our shared library targets
if(CMAKE_HOST_SYSTEM_NAME MATCHES "OpenBSD")
  set(CAF_LIB_VERSION "${CAF_VERSION_MAJOR}.${CAF_VERSION_MINOR}")
else()
  set(CAF_LIB_VERSION "${CAF_VERSION}")
endif()

################################################################################
#   set output paths for binaries and libraries if not provided by the user    #
################################################################################

# prohibit in-source builds
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
    message(FATAL_ERROR "In-source builds are not allowed. Please use "
                        "./configure to choose a build directory and "
                        "initialize the build configuration.")
endif()
# set module path appropriately
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
# set binary output path if not defined by user
if(NOT EXECUTABLE_OUTPUT_PATH)
  set(EXECUTABLE_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}/bin")
endif()
# set library output path if not defined by user, but always set
# library output path to binary output path for Xcode projects
if(CMAKE_GENERATOR STREQUAL "Xcode")
  set(LIBRARY_OUTPUT_PATH "${EXECUTABLE_OUTPUT_PATH}")
elseif(NOT LIBRARY_OUTPUT_PATH)
  set(LIBRARY_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}/lib")
endif()


################################################################################
#                                compiler setup                                #
################################################################################

# leave most compiler flags alone when building as subdirectory
if (NOT caf_is_subproject)
  # check for g++ >= 4.8 or clang++ > = 3.2
  if(NOT WIN32 AND NOT CAF_NO_COMPILER_CHECK AND NOT CMAKE_CROSSCOMPILING)
    try_run(ProgramResult
            CompilationSucceeded
            "${CMAKE_CURRENT_BINARY_DIR}"
            "${CMAKE_CURRENT_SOURCE_DIR}/cmake/get_compiler_version.cpp"
            RUN_OUTPUT_VARIABLE CompilerVersion)
    if(NOT CompilationSucceeded OR NOT ProgramResult EQUAL 0)
      message(FATAL_ERROR "Cannot determine compiler version")
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
      if(CompilerVersion VERSION_GREATER 4.7)
        message(STATUS "Found g++ version ${CompilerVersion}")
      else()
        message(FATAL_ERROR "g++ >= 4.8 required (found: ${CompilerVersion})")
      endif()
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      if(CompilerVersion VERSION_GREATER 3.1)
        message(STATUS "Found clang++ version ${CompilerVersion}")
      else()
        message(FATAL_ERROR "clang++ >= 3.2 required (found: ${CompilerVersion})")
      endif()
    else()
      message(FATAL_ERROR "Your C++ compiler does not support C++11 "
                          "or is not supported")
    endif()
  endif()
  # set optional build flags
  # increase max. template depth on GCC and Clang
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang"
     OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    build_string("EXTRA_FLAGS" "-ftemplate-depth=512 -ftemplate-backtrace-limit=0")
  endif()
  # explicitly disable obnoxious GCC warnings
  if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    build_string("EXTRA_FLAGS" "-Wno-missing-field-initializers")
  endif()
  # add "-Werror" flag if --pedantic-build is used
  if(CAF_CXX_WARNINGS_AS_ERRORS)
    build_string("EXTRA_FLAGS" "-Werror")
  endif()
  # set compiler flags for GCOV if requested
  if(CAF_ENABLE_GCOV)
    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      set(NO_INLINE "-fno-inline")
    else()
      set(NO_INLINE "-fno-inline -fno-inline-small-functions -fno-default-inline")
    endif()
    build_string("EXTRA_FLAGS" "-fprofile-arcs -ftest-coverage ${NO_INLINE}")
  endif()
  # set -fno-exception if requested
  if(CAF_FORCE_NO_EXCEPTIONS)
    build_string("EXTRA_FLAGS" "-fno-exceptions")
  endif()
  # enable a ton of warnings if --more-clang-warnings is used
  if(CAF_MORE_WARNINGS)
    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      set(WFLAGS "-Weverything -Wno-c++98-compat -Wno-padded "
                 "-Wno-documentation-unknown-command -Wno-exit-time-destructors "
                 "-Wno-global-constructors -Wno-missing-prototypes "
                 "-Wno-c++98-compat-pedantic -Wno-unused-member-function "
                 "-Wno-unused-const-variable -Wno-switch-enum "
                 "-Wno-abstract-vbase-init -Wno-shadow "
                 "-Wno-missing-noreturn -Wno-covered-switch-default")
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
      set(WFLAGS "-Waddress -Wall -Warray-bounds "
                 "-Wattributes -Wbuiltin-macro-redefined -Wcast-align "
                 "-Wcast-qual -Wchar-subscripts -Wclobbered -Wcomment "
                 "-Wconversion -Wconversion-null -Wcoverage-mismatch "
                 "-Wcpp -Wdelete-non-virtual-dtor -Wdeprecated "
                 "-Wdeprecated-declarations -Wdiv-by-zero -Wdouble-promotion "
                 "-Wempty-body -Wendif-labels -Wenum-compare -Wextra "

=== doc/CMakeLists.txt ===
add_custom_target(doc)

# -- process .in files ---------------------------------------------------------

configure_file("cmake/Doxyfile.in"
               "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
               @ONLY)

# -- Doxygen setup -------------------------------------------------------------

find_package(Doxygen)

if(NOT DOXYGEN_FOUND)
  message(STATUS "Doxygen not found, skip building API documentation.")
else()
  message(STATUS "Add optional target: doxygen.")
  add_custom_target(doxygen "${DOXYGEN_EXECUTABLE}"
                    "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
                    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
                    COMMENT "Generating API documentation with Doxygen"
                    VERBATIM)
  add_dependencies(doc doxygen)
endif()

=== examples/CMakeLists.txt ===
project(caf_examples CXX)

add_custom_target(all_examples)

include_directories(${CAF_INCLUDE_DIRS})

macro(add folder name)
  add_executable(${name} ${folder}/${name}.cpp ${ARGN})
  target_link_libraries(${name}
                        ${CAF_EXTRA_LDFLAGS}
                        ${CAF_LIBRARIES}
                        ${PTHREAD_LIBRARIES})
  install(FILES ${folder}/${name}.cpp DESTINATION ${CMAKE_INSTALL_DATADIR}/caf/examples/${folder})
  add_dependencies(${name} all_examples)
endmacro()

# introductionary applications
add(. aout)
add(. hello_world)

# basic message passing primitives
add(message_passing calculator)
add(message_passing cell)
add(message_passing dancing_kirby)
add(message_passing delegating)
add(message_passing divider)
add(message_passing fixed_stack)
add(message_passing promises)
add(message_passing request)
add(message_passing typed_calculator)

# streaming API
add(streaming integer_stream)

# dynamic behavior changes using 'become'
add(dynamic_behavior skip_messages)
add(dynamic_behavior dining_philosophers)

# composing actors using states or other actors
add(composition calculator_behavior)
add(composition dictionary_behavior)

# adding custom message types
add(custom_type custom_types_1)
add(custom_type custom_types_2)
add(custom_type custom_types_3)

# basic remoting
add(remoting group_chat)
add(remoting group_server)
add(remoting remote_spawn)
add(remoting distributed_calculator)

# basic I/O with brokers
add(broker simple_broker)
add(broker simple_http_broker)

# testing DSL
add(testing ping_pong)

if(CAF_BUILD_PROTOBUF_EXAMPLES)
  find_package(Protobuf)
  if(PROTOBUF_FOUND AND PROTOBUF_PROTOC_EXECUTABLE)
    PROTOBUF_GENERATE_CPP(ProtoSources ProtoHeaders "${CMAKE_CURRENT_SOURCE_DIR}/remoting/pingpong.proto")
    include_directories(${PROTOBUF_INCLUDE_DIR})
    # add binary dir as include path as generated headers will be located there
    include_directories(${CMAKE_CURRENT_BINARY_DIR})
    add_executable(protobuf_broker broker/protobuf_broker.cpp ${ProtoSources})
    target_link_libraries(protobuf_broker ${CMAKE_DL_LIBS} ${CAF_LIBRARIES} ${PTHREAD_LIBRARIES} ${PROTOBUF_LIBRARIES})
    add_dependencies(protobuf_broker all_examples)
  endif(PROTOBUF_FOUND AND PROTOBUF_PROTOC_EXECUTABLE)
endif()

if(CAF_BUILD_QT_EXAMPLES)
  find_package(Qt5 COMPONENTS Core Gui Widgets QUIET)
  if(Qt5_FOUND)
    message(STATUS "Found Qt5")
    #include(${QT_USE_FILE})
    QT5_ADD_RESOURCES(GROUP_CHAT_RCS )
    QT5_WRAP_UI(GROUP_CHAT_UI_HDR qtsupport/chatwindow.ui)
    QT5_WRAP_CPP(GROUP_CHAT_MOC_SRC qtsupport/chatwidget.hpp)
    # generated headers will be in cmake build directory
    #include_directories(. qtsupport ${CMAKE_CURRENT_BINARY_DIR} ${CPPA_INCLUDE})
    include_directories(qtsupport
                        ${CMAKE_CURRENT_BINARY_DIR}
                        ${Qt5Core_INCLUDE_DIRS}
                        ${Qt5Gui_INCLUDE_DIRS}
                        ${Qt5Widgets_INCLUDE_DIRS})
    set(GROUP_CHAT_SRC qtsupport/qt_group_chat.cpp qtsupport/chatwidget.cpp)
    add_executable(qt_group_chat
                   ${GROUP_CHAT_SRC}
                   ${GROUP_CHAT_MOC_SRC}
                   ${GROUP_CHAT_UI_HDR})
    target_link_libraries(qt_group_chat
                          ${CMAKE_DL_LIBS}
                          ${CAF_LIBRARIES}
                          Qt5::Core
                          Qt5::Gui
                          Qt5::Widgets)
    add_dependencies(qt_group_chat all_examples)
  else()
    find_package(Qt4)
    if(QT4_FOUND)
      message(STATUS "Found Qt4")
      include(${QT_USE_FILE})
      QT4_ADD_RESOURCES(GROUP_CHAT_RCS )
      QT4_WRAP_UI(GROUP_CHAT_UI_HDR qtsupport/chatwindow.ui)
      QT4_WRAP_CPP(GROUP_CHAT_MOC_SRC qtsupport/chatwidget.hpp)
      # generated headers will be in cmake build directory
      #include_directories(. qtsupport ${CMAKE_CURRENT_BINARY_DIR} ${CPPA_INCLUDE})
      include_directories(qtsupport ${CMAKE_CURRENT_BINARY_DIR})
      set(GROUP_CHAT_SRCS qtsupport/qt_group_chat.cpp qtsupport/chatwidget.cpp)
      add_executable(qt_group_chat
                     ${GROUP_CHAT_SRCS}
                     ${GROUP_CHAT_MOC_SRC}
                     ${GROUP_CHAT_UI_HDR})
      target_link_libraries(qt_group_chat
                            ${CMAKE_DL_LIBS}
                            ${CAF_LIBRARIES}
                            ${QT_LIBRARIES})
      add_dependencies(qt_group_chat all_examples)
    endif()
  endif()
endif()

if(NOT CAF_NO_CURL_EXAMPLES)
  find_package(CURL)
  if(CURL_FOUND)
    add_executable(curl_fuse curl/curl_fuse.cpp)
    include_directories(${CURL_INCLUDE_DIRS})
    target_link_libraries(curl_fuse ${CMAKE_DL_LIBS} ${CAF_LIBRARIES} ${PTHREAD_LIBRARIES} ${CURL_LIBRARY})
    add_dependencies(curl_fuse all_examples)
  endif(CURL_FOUND)
endif()

=== libcaf_core/CMakeLists.txt ===
# get header files; only needed by CMake generators,
# e.g., for creating proper Xcode projects
file(GLOB_RECURSE LIBCAF_CORE_HDRS "caf/*.hpp")

# extend the consistency-check target for enum to_string implementations
add_enum_consistency_check("caf/sec.hpp" "src/sec_strings.cpp")
add_enum_consistency_check("caf/pec.hpp" "src/pec_strings.cpp")
add_enum_consistency_check("caf/stream_priority.hpp"
                           "src/stream_priority_strings.cpp")
add_enum_consistency_check("caf/exit_reason.hpp"
                           "src/exit_reason_strings.cpp")
add_enum_consistency_check("caf/invoke_message_result.hpp"
                           "src/invoke_msg_result_strings.cpp")
add_enum_consistency_check("caf/message_priority.hpp"
                           "src/message_priority_strings.cpp")
add_enum_consistency_check("caf/intrusive/inbox_result.hpp"
                           "src/intrusive/inbox_result_strings.cpp")
add_enum_consistency_check("caf/intrusive/task_result.hpp"
                           "src/intrusive/task_result_strings.cpp")

# list cpp files excluding platform-dependent files
set(LIBCAF_CORE_SRCS
  src/abstract_actor.cpp
  src/abstract_channel.cpp
  src/abstract_composable_behavior.cpp
  src/abstract_group.cpp
  src/actor.cpp
  src/actor_addr.cpp
  src/actor_clock.cpp
  src/actor_companion.cpp
  src/actor_config.cpp
  src/actor_control_block.cpp
  src/actor_ostream.cpp
  src/actor_pool.cpp
  src/actor_profiler.cpp
  src/actor_proxy.cpp
  src/actor_registry.cpp
  src/actor_system.cpp
  src/actor_system_config.cpp
  src/atom.cpp
  src/attachable.cpp
  src/behavior.cpp
  src/binary_deserializer.cpp
  src/blocking_actor.cpp
  src/config_option.cpp
  src/config_option_adder.cpp
  src/config_option_set.cpp
  src/config_value.cpp
  src/decorator/sequencer.cpp
  src/decorator/splitter.cpp
  src/default_attachable.cpp
  src/defaults.cpp
  src/deserializer.cpp
  src/detail/abstract_worker.cpp
  src/detail/abstract_worker_hub.cpp
  src/detail/append_hex.cpp
  src/detail/append_percent_encoded.cpp
  src/detail/behavior_impl.cpp
  src/detail/behavior_stack.cpp
  src/detail/blocking_behavior.cpp
  src/detail/concatenated_tuple.cpp
  src/detail/decorated_tuple.cpp
  src/detail/dynamic_message_data.cpp
  src/detail/fnv_hash.cpp
  src/detail/get_mac_addresses.cpp
  src/detail/get_process_id.cpp
  src/detail/get_root_uuid.cpp
  src/detail/ini_consumer.cpp
  src/detail/invoke_result_visitor.cpp
  src/detail/merged_tuple.cpp
  src/detail/message_data.cpp
  src/detail/parse.cpp
  src/detail/parser/chars.cpp
  src/detail/pretty_type_name.cpp
  src/detail/private_thread.cpp
  src/detail/ripemd_160.cpp
  src/detail/serialized_size.cpp
  src/detail/set_thread_name.cpp
  src/detail/shared_spinlock.cpp
  src/detail/simple_actor_clock.cpp
  src/detail/stringification_inspector.cpp
  src/detail/sync_request_bouncer.cpp
  src/detail/test_actor_clock.cpp
  src/detail/thread_safe_actor_clock.cpp
  src/detail/tick_emitter.cpp
  src/detail/try_match.cpp
  src/detail/uri_impl.cpp
  src/downstream_manager.cpp
  src/downstream_manager_base.cpp
  src/duration.cpp
  src/error.cpp
  src/event_based_actor.cpp
  src/execution_unit.cpp
  src/exit_reason.cpp
  src/exit_reason_strings.cpp
  src/forwarding_actor_proxy.cpp
  src/group.cpp
  src/group_manager.cpp
  src/group_module.cpp
  src/inbound_path.cpp
  src/intrusive/inbox_result_strings.cpp
  src/intrusive/task_result_strings.cpp
  src/invoke_msg_result_strings.cpp
  src/ipv4_address.cpp
  src/ipv4_endpoint.cpp
  src/ipv4_subnet.cpp
  src/ipv6_address.cpp
  src/ipv6_endpoint.cpp
  src/ipv6_subnet.cpp
  src/local_actor.cpp
  src/logger.cpp
  src/mailbox_element.cpp
  src/make_config_option.cpp
  src/match_case.cpp
  src/memory_managed.cpp
  src/message.cpp
  src/message_builder.cpp
  src/message_handler.cpp
  src/message_priority_strings.cpp
  src/message_view.cpp
  src/monitorable_actor.cpp
  src/node_id.cpp
  src/outbound_path.cpp
  src/pec.cpp
  src/pec_strings.cpp
  src/policy/downstream_messages.cpp
  src/policy/unprofiled.cpp
  src/policy/work_sharing.cpp
  src/policy/work_stealing.cpp
  src/proxy_registry.cpp
  src/raise_error.cpp
  src/raw_event_based_actor.cpp
  src/ref_counted.cpp
  src/replies_to.cpp
  src/response_promise.cpp
  src/resumable.cpp
  src/rtti_pair.cpp
  src/runtime_settings_map.cpp
  src/scheduled_actor.cpp
  src/scheduler/abstract_coordinator.cpp
  src/scheduler/test_coordinator.cpp
  src/scoped_actor.cpp
  src/scoped_execution_unit.cpp
  src/sec.cpp
  src/sec_strings.cpp
  src/serializer.cpp
  src/settings.cpp
  src/skip.cpp
  src/stream_aborter.cpp
  src/stream_manager.cpp
  src/stream_priority_strings.cpp
  src/string_algorithms.cpp
  src/string_view.cpp
  src/term.cpp
  src/thread_hook.cpp
  src/timestamp.cpp
  src/type_erased_tuple.cpp
  src/type_erased_value.cpp
  src/uniform_type_info_map.cpp
  src/uri.cpp
  src/uri_builder.cpp
)

# configure build_config.hpp header
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/../cmake/build_config.hpp.in"
               "${CMAKE_CURRENT_BINARY_DIR}/caf/detail/build_config.hpp"
               @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/caf/detail/build_config.hpp"
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/caf/detail)

list(APPEND LIBCAF_CORE_HDRS
  "${CMAKE_CURRENT_BINARY_DIR}/caf/detail/build_config.hpp")

add_custom_target(libcaf_core)

# build shared library if not compiling static only
if (NOT CAF_BUILD_STATIC_ONLY)
  add_library(libcaf_core_shared SHARED ${LIBCAF_CORE_SRCS} ${LIBCAF_CORE_HDRS})
  target_link_libraries(libcaf_core_shared ${CAF_EXTRA_LDFLAGS})
  target_include_directories(libcaf_core_shared PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
  )
  set_target_properties(libcaf_core_shared
    PROPERTIES
    SOVERSION ${CAF_VERSION}
    VERSION ${CAF_LIB_VERSION}
    OUTPUT_NAME caf_core
  )
  install(TARGETS libcaf_core_shared
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
  add_dependencies(libcaf_core_shared libcaf_core)
endif ()

# build static library only if --build-static or --build-static-only was set
if (CAF_BUILD_STATIC_ONLY OR CAF_BUILD_STATIC)
  add_library(libcaf_core_static STATIC ${LIBCAF_CORE_HDRS} ${LIBCAF_CORE_SRCS})
  target_link_libraries(libcaf_core_static ${CAF_EXTRA_LDFLAGS})
  target_include_directories(libcaf_core_static PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
  )
  set_target_properties(libcaf_core_static PROPERTIES OUTPUT_NAME caf_core_static)
  install(TARGETS libcaf_core_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
  add_dependencies(libcaf_core_static libcaf_core)
endif ()

install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/caf"
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        FILES_MATCHING PATTERN "*.hpp"
)

# -- build unit tests ----------------------------------------------------------

if(CAF_NO_UNIT_TESTS)
  return()
endif()

add_executable(caf-core-test test/core-test.cpp)

target_include_directories(caf-core-test PRIVATE
                           "${CMAKE_CURRENT_SOURCE_DIR}/test")

if (CAF_BUILD_STATIC_ONLY OR CAF_BUILD_STATIC)
  target_link_libraries(caf-core-test libcaf_core_static  ${CAF_EXTRA_LDFLAGS})
else()
  target_link_libraries(caf-core-test libcaf_core_shared  ${CAF_EXTRA_LDFLAGS})
endif()

caf_add_test_suites(caf-core-test
  actor_clock
  actor_factory
  actor_lifetime
  actor_pool
  actor_profiler
  actor_registry
  actor_system_config
  actor_termination
  aout
  behavior
  blocking_actor
  broadcast_downstream_manager
  byte
  composition
  config_option
  config_option_set
  config_value
  config_value_adaptor
  constructor_attach
  continuous_streaming
  cow_tuple
  decorator.sequencer
  deep_to_string
  detached_actors
  detail.bounds_checker
  detail.ini_consumer
  detail.limited_vector
  detail.parse
  detail.parser.read_bool
  detail.parser.read_floating_point
  detail.parser.read_ini
  detail.parser.read_number
  detail.parser.read_number_or_timespan
  detail.parser.read_signed_integer
  detail.parser.read_string
  detail.parser.read_timespan
  detail.parser.read_unsigned_integer
  detail.ringbuffer
  detail.ripemd_160
  detail.serialized_size
  detail.tick_emitter
  detail.unique_function
  detail.unordered_flat_map
  dictionary
  dynamic_spawn
  expected
  function_view
  fused_downstream_manager
  handles
  inspector
  intrusive.drr_cached_queue
  intrusive.drr_queue
  intrusive.fifo_inbox
  intrusive.lifo_inbox
  intrusive.task_queue
  intrusive.wdrr_dynamic_multiplexed_queue
  intrusive.wdrr_fixed_multiplexed_queue
  intrusive_ptr
  ipv4_address
  ipv4_endpoint
  ipv4_subnet
  ipv6_address
  ipv6_endpoint
  ipv6_subnet
  local_group
  logger
  mailbox_element
  make_config_value_field
  message
  message_id
  message_lifetime
  metaprogramming
  mixin.requester
  mixin.sender
  mock_streaming_classes
  native_streaming_classes
  node_id
  optional
  or_else
  pipeline_streaming
  policy.categorized
  request_timeout
  result
  selective_streaming
  serialization
  settings
  simple_timeout
  span
  stateful_actor
  string_algorithms
  string_view
  sum_type
  thread_hook
  typed_behavior
  typed_response_promise
  typed_spawn
  unit
  uri
  variant
)

if(NOT CAF_NO_EXCEPTIONS)
  caf_add_test_suites(caf-core-test custom_exception_handler)
endif()

=== libcaf_io/CMakeLists.txt ===
# get header files; only needed by CMake generators,
# e.g., for creating proper Xcode projects
file(GLOB_RECURSE LIBCAF_IO_HDRS "caf/*.hpp")

add_enum_consistency_check("caf/io/basp/message_type.hpp"
                           "src/io/basp/message_type_strings.cpp")

add_enum_consistency_check("caf/io/network/operation.hpp"
                           "src/io/network/operation_strings.cpp")

# list cpp files excluding platform-dependent files
set(LIBCAF_IO_SRCS
  src/detail/socket_guard.cpp
  src/io/abstract_broker.cpp
  src/io/basp/header.cpp
  src/io/basp/instance.cpp
  src/io/basp/message_queue.cpp
  src/io/basp/message_type_strings.cpp
  src/io/basp/routing_table.cpp
  src/io/basp/worker.cpp
  src/io/basp_broker.cpp
  src/io/broker.cpp
  src/io/connection_helper.cpp
  src/io/datagram_servant.cpp
  src/io/doorman.cpp
  src/io/middleman.cpp
  src/io/middleman_actor.cpp
  src/io/middleman_actor_impl.cpp
  src/io/network/acceptor.cpp
  src/io/network/acceptor_manager.cpp
  src/io/network/datagram_handler.cpp
  src/io/network/datagram_manager.cpp
  src/io/network/datagram_servant_impl.cpp
  src/io/network/default_multiplexer.cpp
  src/io/network/doorman_impl.cpp
  src/io/network/event_handler.cpp
  src/io/network/interfaces.cpp
  src/io/network/ip_endpoint.cpp
  src/io/network/manager.cpp
  src/io/network/multiplexer.cpp
  src/io/network/native_socket.cpp
  src/io/network/operation_strings.cpp
  src/io/network/pipe_reader.cpp
  src/io/network/protocol.cpp
  src/io/network/receive_buffer.cpp
  src/io/network/scribe_impl.cpp
  src/io/network/stream.cpp
  src/io/network/stream_manager.cpp
  src/io/network/test_multiplexer.cpp
  src/io/scribe.cpp
  src/policy/tcp.cpp
  src/policy/udp.cpp
)

add_custom_target(libcaf_io)

# build shared library if not compiling static only
if (NOT CAF_BUILD_STATIC_ONLY)
  add_library(libcaf_io_shared SHARED ${LIBCAF_IO_SRCS} ${LIBCAF_IO_HDRS})
  target_link_libraries(libcaf_io_shared ${CAF_EXTRA_LDFLAGS} ${CAF_LIBRARY_CORE})
  target_include_directories(libcaf_io_shared PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
  )
  set_target_properties(libcaf_io_shared
                        PROPERTIES
                        SOVERSION ${CAF_VERSION}
                        VERSION ${CAF_LIB_VERSION}
                        OUTPUT_NAME caf_io)
  install(TARGETS libcaf_io_shared
          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
  add_dependencies(libcaf_io_shared libcaf_io)
endif ()

# build static library only if --build-static or --build-static-only was set
if (CAF_BUILD_STATIC_ONLY OR CAF_BUILD_STATIC)
  add_library(libcaf_io_static STATIC ${LIBCAF_IO_HDRS} ${LIBCAF_IO_SRCS})
  target_link_libraries(libcaf_io_static ${CAF_EXTRA_LDFLAGS} ${CAF_LIBRARY_CORE_STATIC})
  target_include_directories(libcaf_io_static PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
  )
  set_target_properties(libcaf_io_static PROPERTIES OUTPUT_NAME caf_io_static)
  install(TARGETS libcaf_io_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
  add_dependencies(libcaf_io_static libcaf_io)
endif ()

# install includes
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/caf
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        FILES_MATCHING PATTERN "*.hpp")

# -- build unit tests ----------------------------------------------------------

if(CAF_NO_UNIT_TESTS)
  return()
endif()

add_executable(caf-io-test test/io-test.cpp)

target_include_directories(caf-io-test PRIVATE
                           "${CMAKE_CURRENT_SOURCE_DIR}/test")

if (CAF_BUILD_STATIC_ONLY OR CAF_BUILD_STATIC)
  target_link_libraries(caf-io-test
                        libcaf_io_static
                        libcaf_core_static
                        ${CAF_EXTRA_LDFLAGS})
else()
  target_link_libraries(caf-io-test
                        libcaf_io_shared
                        libcaf_core_shared
                        ${CAF_EXTRA_LDFLAGS})
endif()

caf_add_test_suites(caf-io-test
  io.basp.message_queue
  io.basp_broker
  io.broker
  io.http_broker
  io.network.default_multiplexer
  io.network.ip_endpoint
  io.receive_buffer
  io.remote_actor
  io.remote_group
  io.remote_spawn
  io.unpublish
  io.worker
)

=== libcaf_opencl/CMakeLists.txt ===
project(caf_opencl C CXX)

# get header files; only needed by CMake generators,
# e.g., for creating proper Xcode projects
file(GLOB_RECURSE LIBCAF_OPENCL_HDRS "caf/*.hpp")

# list cpp files excluding platform-dependent files
set(LIBCAF_OPENCL_SRCS
  src/device.cpp
  src/global.cpp
  src/manager.cpp
  src/opencl_err.cpp
  src/platform.cpp
  src/program.cpp
)

# build shared library if not compiling static only
if(NOT CAF_BUILD_STATIC_ONLY)
  add_library(libcaf_opencl_shared SHARED ${LIBCAF_OPENCL_SRCS}
              ${LIBCAF_OPENCL_HDRS} ${OpenCL_INCLUDE_DIRS})
  target_link_libraries(libcaf_opencl_shared ${CAF_EXTRA_LDFLAGS}
                                             ${CAF_LIBRARY_CORE}
                                             ${OpenCL_LIBRARIES})
  target_link_libraries(libcaf_opencl_shared
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
  )
  set_target_properties(libcaf_opencl_shared
                        PROPERTIES
                        SOVERSION "${CAF_VERSION}"
                        VERSION "${CAF_LIB_VERSION}"
                        OUTPUT_NAME caf_opencl)
  install(TARGETS libcaf_opencl_shared LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# build static library only if --build-static or --build-static-only was set
if(CAF_BUILD_STATIC_ONLY OR CAF_BUILD_STATIC)
  add_library(libcaf_opencl_static STATIC ${LIBCAF_OPENCL_SRCS}
                                          ${LIBCAF_OPENCL_HDRS}
                                          ${OpenCL_INCLUDE_DIRS})
  target_link_libraries(libcaf_opencl_static ${CAF_EXTRA_LDFLAGS}
                                             ${CAF_LIBRARY_CORE_STATIC}
                                             ${OpenCL_LIBRARIES})
  target_link_libraries(libcaf_opencl_static
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
  )
  set_target_properties(libcaf_opencl_static PROPERTIES OUTPUT_NAME caf_opencl_static)
  install(TARGETS libcaf_opencl_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

# install includes
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/caf
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
        FILES_MATCHING PATTERN "*.hpp")

=== libcaf_openssl/CMakeLists.txt ===
project(caf_openssl C CXX)

# get header files; only needed by CMake generators,
# e.g., for creating proper Xcode projects
file(GLOB_RECURSE LIBCAF_OPENSSL_HDRS "caf/*.hpp")

# list cpp files excluding platform-dependent files
set(LIBCAF_OPENSSL_SRCS
  src/openssl/manager.cpp
  src/openssl/middleman_actor.cpp
  src/openssl/publish.cpp
  src/openssl/remote_actor.cpp
  src/openssl/session.cpp
)

add_custom_target(libcaf_openssl)

if (MINGW)
  set(OPENSSL_LIBRARIES ${OPENSSL_LIBRARIES} -lz)
endif()
# build shared library if not compiling static only
if (NOT CAF_BUILD_STATIC_ONLY)
  add_library(libcaf_openssl_shared SHARED
              ${LIBCAF_OPENSSL_SRCS} ${LIBCAF_OPENSSL_HDRS})
  target_link_libraries(libcaf_openssl_shared ${CAF_EXTRA_LDFLAGS}
                        ${CAF_LIBRARY_CORE} ${CAF_LIBRARY_IO} ${OPENSSL_LIBRARIES})

  if(NOT APPLE AND NOT WIN32)
    target_link_libraries(libcaf_openssl_shared "-pthread")
  endif()

  set_target_properties(libcaf_openssl_shared
                        PROPERTIES
                        SOVERSION ${CAF_VERSION}
                        VERSION ${CAF_LIB_VERSION}
                        OUTPUT_NAME caf_openssl)
  if (CYGWIN)
    install(TARGETS libcaf_openssl_shared RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
  elseif (NOT WIN32)
    install(TARGETS libcaf_openssl_shared LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
  endif()
  add_dependencies(libcaf_openssl_shared libcaf_openssl)
endif ()

# build static library only if --build-static or --build-static-only was set
if (CAF_BUILD_STATIC_ONLY OR CAF_BUILD_STATIC)
  add_library(libcaf_openssl_static STATIC
              ${LIBCAF_OPENSSL_HDRS} ${LIBCAF_OPENSSL_SRCS})
  target_link_libraries(libcaf_openssl_static ${CAF_EXTRA_LDFLAGS}
                        ${CAF_LIBRARY_CORE_STATIC} ${CAF_LIBRARY_IO_STATIC} ${OPENSSL_LIBRARIES})
  set_target_properties(libcaf_openssl_static PROPERTIES
                        OUTPUT_NAME caf_openssl_static)
  if(NOT WIN32)
    install(TARGETS libcaf_openssl_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
  endif()
  add_dependencies(libcaf_openssl_static libcaf_openssl)
endif ()

link_directories(${LD_DIRS})
include_directories(. ${INCLUDE_DIRS})

# install includes
if(NOT WIN32)
  install(DIRECTORY caf/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/caf FILES_MATCHING PATTERN "*.hpp")
endif()

# -- build unit tests ----------------------------------------------------------

if(CAF_NO_UNIT_TESTS)
  return()
endif()

add_executable(caf-openssl-test test/openssl-test.cpp)

target_include_directories(caf-openssl-test PRIVATE
                           "${CMAKE_CURRENT_SOURCE_DIR}/test")

if (CAF_BUILD_STATIC_ONLY OR CAF_BUILD_STATIC)
  target_link_libraries(caf-openssl-test
                        libcaf_openssl_static
                        libcaf_io_static
                        libcaf_core_static
                        ${CAF_EXTRA_LDFLAGS})
else()
  target_link_libraries(caf-openssl-test
                        libcaf_openssl_shared
                        libcaf_io_shared
                        libcaf_core_shared
                        ${CAF_EXTRA_LDFLAGS})
endif()

caf_add_test_suites(caf-openssl-test
  openssl.authentication
  openssl.remote_actor
)

=== libcaf_python/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(caf_cash CXX)

# check whether submodules are available
if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/pybind/CMakeLists.txt")
  message(STATUS "Pybind submodule not loaded, skip libcaf_python.")
  set(CAF_NO_PYTHON yes)
else()
  if(NOT "${CAF_PYTHON_CONFIG_BIN}" STREQUAL "")
    execute_process(COMMAND "${CAF_PYTHON_CONFIG_BIN}" --includes
                    OUTPUT_VARIABLE PYTHON_INCLUDE_FLAGS)
    string(STRIP "${PYTHON_INCLUDE_FLAGS}" PYTHON_INCLUDE_FLAGS)
    execute_process(COMMAND "${CAF_PYTHON_CONFIG_BIN}" --ldflags
                    OUTPUT_VARIABLE PYTHON_LDFLAGS)
    string(STRIP "${PYTHON_LDFLAGS}" PYTHON_LDFLAGS)
    if ("${CAF_EXTRA_LDFLAGS}" STREQUAL "")
      set(CAF_EXTRA_LDFLAGS "${PYTHON_LDFLAGS}")
    else()
      set(CAF_EXTRA_LDFLAGS "${CAF_EXTRA_LDFLAGS} ${PYTHON_LDFLAGS}")
    endif()
    string(REPLACE " -I" ";-I" dir_list ${PYTHON_INCLUDE_FLAGS})
    foreach(flag ${dir_list})
      # strip -I from each path
      string(SUBSTRING "${flag}" 2 -1 dir)
      include_directories("${dir}")
    endforeach()
  else()
    find_package(PythonLibs)
    if (NOT PYTHONLIBS_FOUND)
      message(STATUS "Unable to find Python, disable Python binding")
      message(STATUS "Set CAF_PYTHON_CONFIG_BIN or use './configure --with-python-config=...' to use python-conf")
      set(CAF_NO_PYTHON yes)
    else()
      message(STATUS "Found Python ${PYTHONLIBS_VERSION_STRING}")
      include_directories(${PYTHON_INCLUDE_DIRS})
    endif()
  endif()
endif()


set(CAF_PYTHON_SRCS src/main.cpp)
set(CAF_PYTHON_HDRS)

# add targets to CMake
if(NOT CAF_NO_PYTHON)
  include_directories("${CMAKE_CURRENT_SOURCE_DIR}")
  add_executable(caf-python ${CAF_PYTHON_SRCS} ${CAF_PYTHON_HDRS})
  target_link_libraries(caf-python
                        ${CAF_EXTRA_LDFLAGS}
                        ${CAF_LIBRARY_CORE}
                        ${CAF_LIBRARY_IO}
                        ${CAF_LIBRARY_RIAC}
                        ${PTHREAD_LIBRARIES}
                        ${LIBEDIT_LIBRARIES}
                        ${PYTHON_LIBRARIES})
  install(TARGETS caf-python DESTINATION ${CMAKE_INSTALL_BINDIR})
else()
  add_custom_target(caf-python SOURCES ${CAF_PYTHON_SRCS} ${CAF_PYTHON_HDRS})
endif()

=== tools/CMakeLists.txt ===
project(caf_tools CXX)

add_custom_target(all_tools)

include_directories(${CAF_INCLUDE_DIRS})

macro(add name)
  add_executable(${name} ${name}.cpp ${ARGN})
  target_link_libraries(${name}
                        ${CAF_EXTRA_LDFLAGS}
                        ${CAF_LIBRARIES}
                        ${PTHREAD_LIBRARIES})
  install(FILES ${name}.cpp DESTINATION ${CMAKE_INSTALL_DATADIR}/caf/tools/${folder})
  add_dependencies(${name} all_tools)
endmacro()

if(WIN32)
  message(STATUS "skip caf-run (not supported on Windows)")
else()
  add(caf-run)
endif()

add(caf-vec)

=== libcaf_opencl/examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(caf_examples_opencl CXX)

if(OpenCL_LIBRARIES AND NOT CAF_NO_EXAMPLES)
  add_custom_target(opencl_examples)
  include_directories(${CAF_INCLUDE_DIRS})
  if(${CMAKE_SYSTEM_NAME} MATCHES "Window")
    set(WSLIB -lws2_32)
  else()
    set(WSLIB)
  endif()
  macro(add name folder)
    add_executable(${name} ${folder}/${name}.cpp ${ARGN})
    target_link_libraries(${name}
                          ${CAF_EXTRA_LDFLAGS}
                          ${CAF_LIBRARIES}
                          ${PTHREAD_LIBRARIES}
                          ${WSLIB}
                          ${OpenCL_LIBRARIES})
    add_dependencies(${name} all_examples)
  endmacro()
  add(proper_matrix .)
  add(simple_matrix .)
  add(scan .)
endif()

=== debian/changelog ===
actor-framework (0.17.6-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1112690)

 -- Adrian Bunk <bunk@debian.org>  Fri, 31 Oct 2025 22:29:12 +0200

actor-framework (0.17.6-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061864

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 00:04:41 +0000

actor-framework (0.17.6-3) unstable; urgency=medium

  * Add patch for missing include needed with GCC 13 (Closes: #1037568)

 -- Hilko Bengen <bengen@debian.org>  Fri, 28 Jul 2023 21:25:33 +0200

actor-framework (0.17.6-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Enable building with recent gcc. Thanks to Lukas Märdian for the patch.
    Closes: #983959

 -- Sascha Steinbiss <satta@debian.org>  Thu, 04 Nov 2021 12:45:28 +0100

actor-framework (0.17.6-2) unstable; urgency=medium

  * Source-only re-upload 

 -- Hilko Bengen <bengen@debian.org>  Thu, 10 Sep 2020 16:28:12 +0200

actor-framework (0.17.6-1) unstable; urgency=medium

  * New upstream version 0.17.6
  * Add patch from upstream PR #1135
  * Add patch to CMakeLists.txt to enable -std=c++14, avoid FTBFS

 -- Hilko Bengen <bengen@debian.org>  Thu, 10 Sep 2020 01:36:18 +0200

actor-framework (0.17.5-1) experimental; urgency=medium

  * Adopt package
  * New upstream version 0.17.5
  * Rename packages following new major upstream version
  * Fix SONAME, Python3 usage
  * Don't install PDF and RST versions of manual

 -- Hilko Bengen <bengen@debian.org>  Sat, 30 May 2020 16:09:53 +0200

=== debian/control ===
Source: actor-framework
Priority: optional
Maintainer: Hilko Bengen <bengen@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 12~),
 cmake,
 libssl-dev,
# ocl-icd-opencl-dev,
# python3-pybind11, pybind11-dev,
 libcurl4-openssl-dev,
 doxygen, pandoc, python3-pandocfilters, graphviz,
Standards-Version: 4.3.0
Section: libs
Homepage: http://www.actor-framework.org/

Package: libcaf-dev
Section: libdevel
Architecture: any
Depends: libcaf-core0.17t64 (= ${binary:Version}),
 libcaf-io0.17t64 (= ${binary:Version}),
 libcaf-openssl0.17t64 (= ${binary:Version}),
 ${misc:Depends}
Recommends: libcaf-doc
Description: Implementation of the Actor Model in C++, development files
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains headers and other files required to develop
 applications against the library.

Package: libcaf-core0.17t64
Provides: ${t64:Provides}
Replaces: libcaf-core0.17
Breaks: libcaf-core0.17 (<< ${source:Version})
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, core library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the core library.

Package: libcaf-io0.17t64
Provides: ${t64:Provides}
Replaces: libcaf-io0.17
Breaks: libcaf-io0.17 (<< ${source:Version})
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, I/O library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the io library required for network transparency.

Package: libcaf-openssl0.17t64
Provides: ${t64:Provides}
Replaces: libcaf-openssl0.17
Breaks: libcaf-openssl0.17 (<< ${source:Version})
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of the Actor Model in C++, OpenSSL library
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains the io library required for TLS encryption
 using OpenSSL.

Package: libcaf-doc
Section: doc
Architecture: all
Breaks: libcaf-dev (<< 0.16.3)
Replaces: libcaf-dev (<< 0.16.3)
Depends: ${misc:Depends}
Description: Implementation of the Actor Model in C++, development files
 The actor-framework library facilitates writing applications based on the
 actor model in C++. It aims to be lightweight, distributed and simple.
 .
 This package contains documentation and examples for the library.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

override_dh_auto_build:
	dh_auto_build -- all doxygen doc

override_dh_install:
	mkdir -p debian/tmp/usr/share/doc/libcaf-doc
	mv debian/tmp/usr/share/caf/examples \
	   debian/tmp/usr/share/doc/libcaf-doc
	dh_install

override_dh_missing:
	dh_missing --fail-missing

%:
	dh $@ --buildsystem=cmake

=== debian/watch ===
version=2

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/actor-framework/actor-framework/tags .*/v?(\d\S*)\.tar\.gz
